'ATtiny85_Sios.bas
$regfile = "attiny85.dat"
$crystal = 8000000
$hwstack = 8
$swstack = 4                                                ' 16
$framesize = 4

Dim Kom As Byte
Dim Dat As Byte
Dim Dd As Word
Dim U As Word
Dim Hi As Byte
Dim Lo As Byte
Dim N As Byte
Dim Nn As Word

Dim D(64) As Byte


Open "comb.2:19200,8,n,1" For Input As #1
Open "comb.1:19200,8,n,1" For Output As #2

Config Adc = Single , Prescaler = 16
Start Adc

Clkpr = 128                                                 '8 MHz
Clkpr = 0
Clkpr = 0

Ddrb = &B00000010

Pwm0a = 0

Do
Interpreter:
  Get #1 , Kom
  If Kom = 1 Then
     Put #2 , 10                                            'SIOS Device 10
     Goto Interpreter
  End If
  If Kom = 2 Then
     Put #2 , 21                                            'Firmware V2.1
     Goto Interpreter
  End If
  If Kom = 16 Then
    Get #1 , Dat
    Dat = Dat And &B00011011
    Dat = Dat Or &B00000010
    Ddrb = Dat
    Portb = Dat
    Goto Interpreter
  End If
  If Kom = 32 Then
     Dat = Pinb
     Put #2 , Dat
     Goto Interpreter
  End If

  If Kom = 48 Then
     U = Getadc(2)
     Shift U , Right , 2
     Put #2 , U
     Goto Interpreter
  End If
  If Kom = 49 Then
     U = Getadc(3)
     Shift U , Right , 2
     Put #2 , U
     Goto Interpreter
  End If
  If Kom = 50 Then
     U = Getadc(0)                                          'ADC0, Reset
     Shift U , Right , 2
     Put #2 , U
     Goto Interpreter
  End If
  If Kom = 51 Then
     U = Getadc(1)                                          'ADC1, B2, Rxd
     Shift U , Right , 2
     Put #2 , U
     Goto Interpreter
  End If
  If Kom = 64 Then
    Get #1 , Dat
    Config Timer0 = Pwm , Prescale = 64 , Compare A Pwm = Clear Up
    Pwm0a = Dat
    Goto Interpreter
  End If
  If Kom = 65 Then
    Get #1 , Dat
    Goto Interpreter
  End If
    If Kom = 56 Then
     U = Getadc(2)
     Hi = High(u)
     Lo = Low(u)
     Put #2 , Hi
     Get #1 , Dat
     Put #2 , Lo
     Goto Interpreter
  End If
  If Kom = 57 Then
     U = Getadc(3)
     Hi = High(u)
     Lo = Low(u)
     Put #2 , Hi
     Get #1 , Dat
     Put #2 , Lo
     Goto Interpreter
  End If
  If Kom = 58 Then
     U = Getadc(0)                                          'ADC0, Reset
     Hi = High(u)
     Lo = Low(u)
     Put #2 , Hi
     Get #1 , Dat
     Put #2 , Lo
     Goto Interpreter
  End If
  If Kom = 59 Then
     U = Getadc(1)                                          'ADC1, B2, Rxd
     Hi = High(u)
     Lo = Low(u)
     Put #2 , Hi
     Get #1 , Dat
     Put #2 , Lo
     Goto Interpreter
  End If
  If Kom = 72 Then                                          'PWM Output 10 Bit
    Get #1 , Hi
    Dd = 256 * Hi
    Get #1 , Lo
    Config Timer0 = Pwm , Prescale = 64 , Compare A Pwm = Clear Up
    Dd = Dd + Lo
    Dd = Dd / 4
    Pwm0a = Dd
    Goto Interpreter
  End If
  If Kom = 73 Then
    Get #1 , Hi
    Get #1 , Lo
    Goto Interpreter
  End If

Loop

Do

Loop