'Freq1.bas    Input B2/RXD
$regfile = "attiny85.dat"
$crystal = 8000000
$hwstack = 8
$swstack = 4
$framesize = 4


Dim T As Word
Dim N As Byte
Dim F As Long

Config Portb.3 = Output
Open "comb.1:9600,8,n,1" For Output As #1

Config Timer0 = Counter , Edge = Falling
Enable Timer0
On Timer0 Tim0isr

Config Timer1 = Timer , Prescale = 32
Enable Timer1
On Timer1 Tim1isr


Do
  F = 0
  T = 0
  Timer0 = 0
  Timer1 = 0
  Enable Interrupts
  Do
  Loop Until T = 1000
  Disable Interrupts
  F = F * 256
  F = F + N
  Print #1 , Chr(13);
  Print #1 , F;
  Print #1 , " Hz            ";
  'Waitms 1000
Loop



Tim0isr:
  F = F + 1
Return


'8 MHz / 32 / 250 = 1 kHz
Tim1isr:
  Timer1 = 6
  Toggle Portb.3
  T = T + 1
  If T = 1000 Then
    N = Timer0
    Disable Interrupts
  End If
Return

End